/*
    This file is a part of the SteamWar software.

    Copyright (C) 2020  SteamWar.de-Serverteam

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

package de.steamwar.misslewars.scripts.implemented;

import com.google.gson.JsonObject;
import de.steamwar.misslewars.scripts.RunnableScript;
import de.steamwar.misslewars.scripts.RunnableScriptEvent;
import de.steamwar.misslewars.scripts.ScriptedItem;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

import static de.steamwar.misslewars.scripts.utils.JsonUtils.getBoolean;
import static de.steamwar.misslewars.scripts.utils.JsonUtils.getInt;

public class PotionScript implements RunnableScript {

    private PotionEffect potionEffect = null;

    public PotionScript(JsonObject potion) {
        int duration = getInt(potion, "duration", 1);
        int amplifier = getInt(potion, "amplifier", 1);
        boolean ambient = getBoolean(potion, "ambient", true);
        boolean particles = getBoolean(potion, "particles", true);
        boolean icon = getBoolean(potion, "icon", true);

        PotionEffectType potionEffectType = PotionEffectType.getByName(potion.getAsJsonPrimitive("potion").getAsString());
        if (potionEffectType == null) return;
        potionEffect = new PotionEffect(potionEffectType, duration, amplifier, ambient, particles, icon);
    }

    @Override
    public boolean execute(RunnableScriptEvent runnableScriptEvent) {
        if (potionEffect == null) return false;
        if (runnableScriptEvent.eventType != ScriptedItem.EventType.onClick) return true;
        runnableScriptEvent.getPlayer().addPotionEffect(potionEffect);
        return true;
    }

}
